<template>
  <div>
    <b-row
      v-show="showDetail || !editableDataUrl || !editableKey"
      id="metadataManagerShownFilesTable"
    >
      <b-col>
        <b-input-group v-for="(item, index) in shownFiles" :key="index">
          <b-button
            variant="outline-secondary"
            :pressed="currentFileId === index"
            @click="$emit('changeMetadata', index)"
            >{{ index + 1 }}</b-button
          >
          <b-button
            class="metadataManagerFileListFileName"
            :pressed="false"
            variant="outline-secondary"
            @click="$emit('changeMetadata', index)"
            >{{ item.path
            }}<b-spinner
              v-show="item.type === 'Leaf' && item.uploading"
              label="Spinning"
            ></b-spinner
          ></b-button>
          <b-button
            class="deleteFolderContentFromList"
            variant="outline-secondary"
            :disabled="item.type === 'Leaf' && item.uploading"
            @click="$emit('removeElement', index)"
            >X</b-button
          >
        </b-input-group>
      </b-col>
    </b-row>
    <b-row v-show="shownFiles.length > 1" id="metadataManagerQuickAccess">
      <b-col>
        <b-button
          :pressed="currentFileId === -1"
          variant="outline-secondary"
          @click="$emit('loadAllFilesTab')"
          >{{ $t("page.resource.allFiles") }}</b-button
        >
        <span v-if="shownFiles.length > 1 && shownFiles.length <= 10">
          <b-button
            v-for="(item, index) in shownFiles"
            :key="index"
            :pressed="currentFileId === index"
            variant="outline-secondary"
            class="metadataTabButton"
            @click="$emit('changeMetadata', index)"
            >{{ index + 1 }}</b-button
          >
        </span>
      </b-col>
    </b-row>
    <b-row id="metadataManagerFileName" class="text-center">
      <b-col id="metadataManagerFileNameInfo">
        <span
          v-if="
            currentFileId >= 0 &&
            currentFileId < shownFiles.length &&
            currentFolderContent
          "
          class="showSpaces"
        >
          <span
            id="metadataManagerFileNameTooltip"
            data-toggle="tooltip"
            :title="currentFolderContent.name"
          >
            {{ currentFolderContent.name }}
            <select
              v-if="
                resource?.metadataExtraction &&
                currentFolderContent.versions.length > 1
              "
              :value="currentFolderContent.latestVersion"
              @change="setVersion($event)"
            >
              <option
                v-for="version in currentFolderContent.versions"
                :key="version"
              >
                {{ version }}
              </option>
            </select>
          </span>
        </span>
        <span v-else-if="shownFiles.length > 0">
          {{ $t("page.resource.allFiles") }}
        </span>
      </b-col>
    </b-row>
  </div>
</template>

<script lang="ts">
import useResourceStore from "@/modules/resource/store";

import type { FolderContent } from "@/modules/resource/types";
import type { ResourceDto } from "@coscine/api-client/dist/types/Coscine.Api";

export default defineComponent({
  props: {
    currentFileId: {
      required: true,
      type: Number,
    },
    currentFolderContent: {
      default: undefined,
      type: [Object, undefined] as PropType<FolderContent | undefined>,
    },
    editableDataUrl: {
      required: true,
      type: Boolean,
    },
    editableKey: {
      required: true,
      type: Boolean,
    },
    showDetail: {
      required: true,
      type: Boolean,
    },
    shownFiles: {
      required: true,
      type: Array as PropType<FolderContent[]>,
    },
  },
  setup() {
    const resourceStore = useResourceStore();

    return {
      resourceStore,
    };
  },
  computed: {
    resource(): null | ResourceDto {
      return this.resourceStore.currentResource;
    },
  },
  methods: {
    setVersion(event: Event) {
      if (event.target) {
        const el = event.target as HTMLSelectElement;
        this.$emit("setVersion", Number(el.value));
      }
    },
  },
});
</script>

<style scoped>
.metadataManagerFileListFileName {
  text-overflow: ellipsis;
}
#metadataManagerFileName {
  margin-top: 5px;
  left: 0;
  right: 0;
}
#metadataManagerFileName :deep(span) {
  text-align: center;
  font-weight: bold;
  width: 100%;
}
#metadataManagerFileNameInfo {
  overflow: hidden;
  white-space: nowrap;
  text-overflow: ellipsis;
}
#metadataManagerShownFilesTable {
  margin-right: -10px;
}
#metadataManagerShownFilesTable :deep(.col) {
  overflow-x: hidden;
  overflow-y: auto;
  max-height: 76px;
  padding-right: 0px;
  margin-right: 15px;
}
#metadataManagerShownFilesTable :deep(.input-group) {
  flex-wrap: initial;
}
#metadataManagerShownFilesTable :deep(.metadataManagerFileListFileName) {
  width: inherit;
  text-overflow: ellipsis;
  overflow: hidden;
  white-space: nowrap;
  text-transform: none;
}
#metadataManagerShownFilesTable :deep(.spinner-border) {
  margin-left: 5px;
}
#metadataManagerShownFilesTable :deep(.deleteFolderContentFromList) {
  color: red;
}
#metadataManagerQuickAccess {
  left: 0;
  right: 0;
}
#metadataManagerQuickAccess :deep(.btn) {
  margin-top: 5px;
  margin-right: 5px;
}
.metadataTabButton {
  max-width: inherit;
  min-width: inherit;
  width: inherit;
}
.showSpaces {
  white-space: pre;
}
button :deep(span.spinner-border) {
  height: 15px;
  width: 15px;
  margin-right: 4px;
}
</style>
